unit Collatz_main1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, SpinEx, lclintf;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnFolge: TButton;
    btnTesten: TButton;
    btnClose: TButton;
    btnSpeichern: TButton;
    gbCollatz: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblWikiLink: TLabel;
    mmoAusgabe: TMemo;
    SaveDialog1: TSaveDialog;
    speEingabe: TSpinEditEx;
    speEingabeA: TSpinEditEx;
    speEingabeB: TSpinEditEx;
    speAnzahl: TSpinEditEx;
    procedure btnCloseClick(Sender: TObject);
    procedure btnFolgeClick(Sender: TObject);
    procedure btnSpeichernClick(Sender: TObject);
    procedure btnTestenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lblWikiLinkClick(Sender: TObject);
  private
    procedure PrimFaktoren(n: Integer);
    procedure TeilerAnzahl(n: integer);
    procedure IstDreieckszahl(n: integer);
    procedure Collatz(n: integer);
    procedure AusgabeIstPrim;
    procedure CollatzAllgemein(n: integer);
  public

  end;

var
  Form1: TForm1;

const
  trenner='--------------';
  primID='*';

implementation

{$R *.lfm}

{ TForm1 }

/////////////////////  Die kopierten Routinen vom Original

function IstPrim(n: Integer): Boolean;
var
  i : Integer;

begin
  result:=(n > 1);
  if result then begin
    for i:=2 to (n div 2) do
      if n mod i = 0 then begin
        result:=false;
        break;
      end;
  end;
end;

procedure TForm1.PrimFaktoren(n: Integer);
var
  i, j : Integer;
  s: string;

begin
  if (n>1) and (not IstPrim(n)) then begin
    s:='Die Primfaktorzerlegung ist: ';
    for i := 2 to n-1 do begin
      j := 0;
      while n mod i = 0 do begin
        n := n div i;
        inc(j)
      end;
      if j > 0 then begin
        if j=1 then
          s:=s+IntToStr(i)
        else
          s:=s+IntToStr(i)+'^'+IntToStr(j);
        if n<>1 then
          s:=s+', ';
      end;
    end;
    mmoAusgabe.Lines.Add(s);
  end;
end;

procedure TForm1.TeilerAnzahl(n: integer);
var
  i, j, s : integer;
  w: string;

begin
  j := 0;
  s := 0;
  if (n>1) and (not IstPrim(n)) then begin
    w:='Die echten Teiler der Zahl '+IntToStr(n)+' sind: ';
    for i := 1 to n div 2 do begin
      if n mod i = 0 then begin
        inc(j);
        s := s + i;
        if i = (n div 2) then
          w:=w+IntToStr(i)
        else
          w:=w+IntToStr(i)+', ';
      end;
    end;
    mmoAusgabe.Lines.Add(w);

    w:='Die Zahl '+IntToStr(n);
    mmoAusgabe.Lines.Add(w+' hat '+IntToStr(j)+' echte Teiler');
    w:=w+' ist ';
    if s < n then
      mmoAusgabe.Lines.Add(w+'defizient mit Teilersumme '+IntToStr(s));
    if s = n then
      mmoAusgabe.Lines.Add(w+'vollkommen');
    if s > n then
      mmoAusgabe.Lines.Add(w+'abundant mit Teilersumme '+IntToStr(s));
  end;
end;

procedure TForm1.IstDreieckszahl(n: integer);
var
  Produkt,teiler: integer;

begin
  Produkt := 0;
  teiler := 0;
  while Produkt < n do begin
    inc(teiler);
    Produkt := (teiler * (teiler+1)) div 2;
    if Produkt > n then
      mmoAusgabe.Lines.Add('Die Zahl '+IntToStr(n)+' ist keine Dreieckszahl')
    else
      if ((n mod Produkt) = 0) and (Produkt div n = 1) then
        mmoAusgabe.Lines.Add('Die Zahl '+IntToStr(n)+' ist die '+IntToStr(teiler)+'-te Dreieckszahl');
  end;
end;

procedure TForm1.Collatz(n: integer);
var
  i, j, k : integer;
  s: string;

begin
  i := n;
  j := 1;
  k := 0;
  if n > 1 then begin
    s:='Die Collatz-Folgenglieder sind: '+IntToStr(n)+', ';
    while i <> 1 do begin
      inc(j);
      if i mod 2 = 0 then
        i := i div 2
      else
        if i mod 2 <> 0 then
          i := (3 * i) +1;
      if IstPrim(i) then begin
        s:=s+primID;                       {Primzahl beginnt mit *}
        inc(k);
      end;
      s:=s+IntToStr(i);
      if i <> 1 then
        s:=s+', ';
    end;
    mmoAusgabe.Lines.Add(s);
    mmoAusgabe.Lines.Add('Die Collatz-Folge hat '+IntToStr(j)+' Glieder, '+
                          IntToStr(k)+' davon sind Primzahlen');
  end;
end;

procedure TForm1.AusgabeIstPrim;
var
  s: string;

begin
  if speEingabe.Value=0 then
    mmoAusgabe.Lines.Add('Die Null ist 0 ! ;)')
  else begin
    s:='Die Zahl '+IntToStr(speEingabe.Value)+' ist ';
    if IstPrim(speEingabe.Value) = true then
      mmoAusgabe.Lines.Add(s+' eine Primzahl')
    else
      mmoAusgabe.Lines.Add(s+' keine Primzahl');
  end;
end;

procedure TForm1.CollatzAllgemein(n: integer);

var
  i,j,k,l: Integer;
  s: string;

begin
  mmoAusgabe.Lines.Add(trenner);
  i := n;
  j := 1;
  k := 0;
  s:='Die ersten '+IntToStr(speAnzahl.Value)+' Collatz-Folgenglieder sind: '+IntToStr(n)+', ';
  while j < speAnzahl.Value do begin
    inc(j);
    if i mod 2 = 0 then
      i := i div 2
    else
      if i mod 2 <> 0 then
        i := (speEingabeA.Value * i) +speEingabeB.Value;
    if IstPrim(i) then begin
      s:=s+primID;
      inc(k);
    end;
    s:=s+IntToStr(i);
    if j < speAnzahl.Value then
      s:=s+', ';
  end;
  mmoAusgabe.Lines.Add(s);

  s:='Die allgemeine Collatz-Folge der Form Ni+1 = n/2 v Ni+1 = '+
      IntToStr(speEingabeA.Value)+'*n+'+IntToStr(speEingabeB.Value)+' hat ';
  if istprim(j) then
    s:=s+primID;
  s:=s+IntToStr(j);
  if j=1 then
    s:=s+' Glied, '
  else
    s:=s+' Glieder, ';
  if istprim(k) then
    s:=s+primID;
  s:=s+IntToStr(k)+' davon sind Primzahlen';
  mmoAusgabe.Lines.Add(s);
end;


/////////////////////  Hier folgt der der GUI-Teil

procedure TForm1.FormCreate(Sender: TObject);        {Formular initialisieren}
begin
  Caption:='Collatz-Folgen';
  mmoAusgabe.Text:='Gebe links eine natürliche Zahl ein und teste sie.'
end;

procedure TForm1.lblWikiLinkClick(Sender: TObject);  {Wiki Link}
begin
  OpenURL(lblWikiLink.Caption);
end;

procedure TForm1.btnCloseClick(Sender: TObject);     {Programm beenden}
begin
  Close;
end;

procedure TForm1.btnFolgeClick(Sender: TObject);     {Allgemeine Collatz-Folge}
begin
  CollatzAllgemein(speEingabe.Value);
end;

procedure TForm1.btnSpeichernClick(Sender: TObject);
begin
  SaveDialog1.FileName:=IntToStr(speEingabe.Value)+'.txt';  {Vorschlag Dateiname}
  if SaveDialog1.Execute then begin
    mmoAusgabe.Lines.SaveToFile(SaveDialog1.FileName);
  end;
end;

procedure TForm1.btnTestenClick(Sender: TObject);    {Zahl testen}
begin
  mmoAusgabe.Lines.Clear;
  AusgabeIstPrim;
  PrimFaktoren(speEingabe.Value);
  TeilerAnzahl(speEingabe.Value);
//  mmoAusgabe.Lines.Add(trenner);                   {Ausgabe eventuell gruppieren}
  IstDreieckszahl(speEingabe.Value);
//  mmoAusgabe.Lines.Add(trenner);                   {Ausgabe eventuell gruppieren}
  Collatz(speEingabe.Value);
end;

end.

